<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSaveTemplate StructType
 * @subpackage Structs
 */
class GetSaveTemplate extends AbstractStructBase
{
    /**
     * The templateName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $templateName;
    /**
     * Constructor method for GetSaveTemplate
     * @uses GetSaveTemplate::setTemplateName()
     * @param string $templateName
     */
    public function __construct($templateName = null)
    {
        $this
            ->setTemplateName($templateName);
    }
    /**
     * Get templateName value
     * @return string|null
     */
    public function getTemplateName()
    {
        return $this->templateName;
    }
    /**
     * Set templateName value
     * @param string $templateName
     * @return \StructType\GetSaveTemplate
     */
    public function setTemplateName($templateName = null)
    {
        // validation for constraint: string
        if (!is_null($templateName) && !is_string($templateName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($templateName)), __LINE__);
        }
        $this->templateName = $templateName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetSaveTemplate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
