<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SubscribeEvent StructType
 * @subpackage Structs
 */
class SubscribeEvent extends AbstractStructBase
{
    /**
     * The eventType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $eventType;
    /**
     * The filter
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $filter;
    /**
     * The callbackUrl
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $callbackUrl;
    /**
     * Constructor method for SubscribeEvent
     * @uses SubscribeEvent::setEventType()
     * @uses SubscribeEvent::setFilter()
     * @uses SubscribeEvent::setCallbackUrl()
     * @param string $eventType
     * @param string $filter
     * @param string $callbackUrl
     */
    public function __construct($eventType = null, $filter = null, $callbackUrl = null)
    {
        $this
            ->setEventType($eventType)
            ->setFilter($filter)
            ->setCallbackUrl($callbackUrl);
    }
    /**
     * Get eventType value
     * @return string
     */
    public function getEventType()
    {
        return $this->eventType;
    }
    /**
     * Set eventType value
     * @uses \EnumType\SubscriptionEventTypes::valueIsValid()
     * @uses \EnumType\SubscriptionEventTypes::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $eventType
     * @return \StructType\SubscribeEvent
     */
    public function setEventType($eventType = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\SubscriptionEventTypes::valueIsValid($eventType)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $eventType, implode(', ', \EnumType\SubscriptionEventTypes::getValidValues())), __LINE__);
        }
        $this->eventType = $eventType;
        return $this;
    }
    /**
     * Get filter value
     * @return string|null
     */
    public function getFilter()
    {
        return $this->filter;
    }
    /**
     * Set filter value
     * @param string $filter
     * @return \StructType\SubscribeEvent
     */
    public function setFilter($filter = null)
    {
        // validation for constraint: string
        if (!is_null($filter) && !is_string($filter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($filter)), __LINE__);
        }
        $this->filter = $filter;
        return $this;
    }
    /**
     * Get callbackUrl value
     * @return string|null
     */
    public function getCallbackUrl()
    {
        return $this->callbackUrl;
    }
    /**
     * Set callbackUrl value
     * @param string $callbackUrl
     * @return \StructType\SubscribeEvent
     */
    public function setCallbackUrl($callbackUrl = null)
    {
        // validation for constraint: string
        if (!is_null($callbackUrl) && !is_string($callbackUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($callbackUrl)), __LINE__);
        }
        $this->callbackUrl = $callbackUrl;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SubscribeEvent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
